//#define DEBUG 1
///////////////////////////////////////////////////////////////
//  puriTEXT Copyright (C) 1994 by Mizutori Tetsuya, 94/3/2  //
///////////////////////////////////////////////////////////////
// version v1.0 94/3/4
// version v1.1 94/3/21

#include <AppleEvents.h>
#include <GestaltEqu.h>
#include <Windows.h>
#include <Values.h>
#include <Script.h>
#include "Defines.h"	// define general macros

// define macros for 'puriTEXT'
#define dCheckMark		gCheckMark
//#define dCheckMark	kCheckMark

#define	AppendMenuItem(menu,text)	\
	{ AppendMenu(menu,"\pttxt");\
	  SetItem(menu,CountMItems(menu),text); }

#define SetItemCheck( menu, item, markChar ) \
	SetItemCmd( menu, item, ( (markChar!=noMark)?dCheckMark:noMark) )
//	SetItemMark( menu, item, markChar )
//	SetItemStyle( menu, item, ( (markChar!=noMark)?outline:plain) )
//	CheckItem( menu, item, ( markChar != noMark ) )

#define GetItemCheck( menu, item, markChar ) \
	GetItemCmd( menu, item, markChar )
//	GetItemMark( menu, item, markChar )
// !!! CAUSION !!!  Usage: GetItemCheck(text,item,&markChar);

//  Prototypes (puriTEXT.c)
/***** main *****/
void main( void );
/***** setup *****/
void InitToolbox( void );
void SetupMenuBar( void );
void AdjustMenu( WindowPtr window );
void SetupCursor( WindowPtr window );
void AdjustCursor( WindowPtr window, Point mousePos );
void DoCloseWindow( WindowPtr window );
void SetupWindow( WindowPtr *window );
void SetupUserItem( WindowPtr window );
pascal void myDrawUserItem( DialogPtr dialog, short item );
/***** Get general information *****/
short GetDAFont( void );
short WindowType( WindowPtr window );
short CBIndex( short item );
/***** EventLoop *****/
void EventLoop( void );
Boolean HandleHitItem( DialogPtr dialog, short item );
/***** DoEvent *****/
void DoEvent( EventRecord *event );
void DoSuspentResume( EventRecord *event );
void DoActivate( WindowPtr window, Boolean becomingActive );
void DoUpdate( WindowPtr window, EventRecord *event );
/***** AEProces event *****/
void SetupAppleEvent( void );
pascal OSErr DoOpenApp( AppleEvent theAppleEvent, AppleEvent reply, long refCon );
pascal OSErr DoOpenDoc( AppleEvent theAppleEvent, AppleEvent reply, long refCon );
pascal OSErr DoPrintDoc( AppleEvent theAppleEvent, AppleEvent reply, long refCon );
pascal OSErr DoQuitApp( AppleEvent theAppleEvent, AppleEvent reply, long refCon );
OSErr GotRequiredParams( AppleEvent *appleEventPtr );
void DoAEError( AppleEvent *theAppleEvent, AppleEvent *reply, OSErr err, long eventID );
/***** Do Purity *****/
void DoPurify( FSSpec *theFSSpec );
void DoGetFInfo( FSSpec *theFSSpec, HFileParam *fInfo );
void DoSetFInfo( FSSpec *theFSSpec, HFileParam *fInfo );
Boolean IsExclude( FSSpec *theFSSpec );
Boolean GetFileCreator( OSType *type );
/***** Handle MouseDown *****/
void HandleMouseDown( EventRecord *event );
void DoContent( WindowPtr window, EventRecord *event );
/***** Handle PopupMenu *****/
Boolean SelectPopupMenu( WindowPtr window, short item, short *curValue );
void AdjustMenuCreator( WindowPtr window );
void AdjustMenuExclude( WindowPtr window );
void HandlePopupChoiceCreator( WindowPtr window, short item );
void HandlePopupChoiceExclude( WindowPtr window, short item );
/***** Do Popup opereation *****/
Boolean TestPopupAdd( WindowPtr window, MenuHandle menu, short item );
Boolean TestPopupAppend( WindowPtr window, MenuHandle menu, short item );
Boolean TestPopupRemove( WindowPtr window, MenuHandle menu, short item );
Boolean DoPopupReset( WindowPtr window, MenuHandle menu, short item );
Boolean DoPopupSetText( WindowPtr window, MenuHandle menu, short item, short itemHit );
Boolean DoPopupAdd( WindowPtr window, MenuHandle menu, short item );
Boolean DoPopupAppend( WindowPtr window, MenuHandle menu, short item );
Boolean DoPopupRemove( WindowPtr window, MenuHandle menu, short item );
Boolean AppendCheckMark( WindowPtr window, MenuHandle menu, short item );
/***** Do key down *****/
void DoKeyDown( char c );
/***** Handle MenuChoice *****/
void HandleMenuChoice( long menuChoice );
void HandleAppleChoice( short item );
void HandleFileChoice( short item );
void HandleEditChoice( short theItem );
/***** Do About *****/
void DoAbout( void );
/***** Do File Open *****/
void DoOpen( void );
void DoSaveAs( void );
void DoSaveHelp( FSSpec *theFSSpec, Boolean replacing );
/***** Do Preference *****/
void SetDefaults( WindowPtr window, PrefDataPtr dataBlock );
void SetGlobals( WindowPtr window, PrefDataPtr dataBlock );
void DoPreference( WindowPtr window );
/***** Dialog operation *****/
void SaveDataBlock( DialogPtr dialog, PrefDataPtr dataBlock );
void LoadDataBlock( DialogPtr dialog, PrefDataPtr dataBlock );
void HiliteButtons( DialogPtr dialog, short hiliteCode );

// end of Prototypes


/***** Constants & Globals *****/
WindowPtr	gWindow = nil;
Boolean		gOpenAppl = false;
Boolean		gOpenDocs = false;
Boolean		gDone = false;
Boolean		gCBCreator = false;
Boolean		gCBModDate = true;
Boolean		gCBBigRF = true;
Boolean		gCBExclude = false;
OSType		gCreator = 'ttxt';
long		gBigRF   = 10*1024;
OSType		gExcludes[kMaxCreators];
short		gNumExcludes = 0;
short		gCheckMark = kCheckMark;
short		gTextFont = geneva;


/***** main *****/
void main( void )
{
	WindowPtr	window;

	InitToolbox();

#ifdef DEBUG
	console_options.nrows = 32;
	cshow( stdout );
#endif DEBUG

	GestaltCheck( gestaltSystemVersion );
	GestaltCheck( gestaltProcessorType );

	SetupMenuBar();
//	SetupWindow( &window );
	SetupAppleEvent();

	EventLoop();

	DoCloseWindow( gWindow );

	ExitToShell();
}

/***** setup *****/
void InitToolbox( void )
{
	InitGraf(&thePort);
	InitFonts();
	InitWindows();
	InitMenus();
	TEInit();
	InitDialogs(nil);
	FlushEvents(everyEvent,0);
	InitCursor();
	ZeroScrap();
	MaxApplZone();
	MoreMasters();	// allocates a block of 64 Handles
	MoreMasters();	// allocates a block of 64 Handles
}

/***** setup menus *****/
void SetupMenuBar( void )
{
	Handle		menuBar;
	MenuHandle	menu;

	menuBar = GetNewMBar( kMenuBarID );
	if ( menuBar == nil ) return;

	SetMenuBar( menuBar );

	menu = GetMHandle( mApple );
	AddResMenu( menu, 'DRVR' );

//	menu = GetMHandle( mFont );
//	AddResMenu( menu, 'FONT' );

	DrawMenuBar();
}

void AdjustMenu( WindowPtr window )
{
	MenuHandle	menu;
	PScrapStuff	pScrpInf;
	TEHandle	teHndl;
	short		i,item;
	short		fileMenu[] = {-iNew,iOpen,-iClose,-iSave,iSaveAs,-iRevert,
							  -iPageSetup,-iPrint,iPreferences,iQuit,0};
	short		editMenu[] = {-iUndo,iCut,iCopy,iPaste,iClear,
							  -iDuplicate,iSelectAll,0};
	short		editMenuSelected[] = {iCut,iCopy,iClear,0};

	switch ( WindowType(window) ) {
		case kMyRefCon:
		default:
			window = gWindow;				// using global 'gWindow' !!!
			break; }

	teHndl = ((DialogPeek)window)->textH;

	switch ( my(window,mode) ) {
		case kNormalMode:
			menu = GetMenu( mFile );
			i = -1; while ( (item=fileMenu[++i]) != 0 ) 
				if ( item > 0 )	EnableItem( menu, item );
				else			DisableItem( menu, -item );
			menu = GetMenu( mEdit );
			i = -1; while ( (item=editMenu[++i]) != 0 ) 
				if ( item > 0 )	DisableItem( menu, item );
				else			DisableItem( menu, -item );
			break;
		case kPrefMode:
			menu = GetMenu( mFile );
			i = -1; while ( (item=fileMenu[++i]) != 0 ) 
				if ( item > 0 )	EnableItem( menu, item );
				else			DisableItem( menu, -item );
				DisableItem( menu, iPreferences );
				DisableItem( menu, iSaveAs );
			menu = GetMenu( mEdit );
			i = -1; while ( (item=editMenu[++i]) != 0 ) 
				if ( item > 0 )	EnableItem( menu, item );
				else			DisableItem( menu, -item );
			pScrpInf = InfoScrap();
			if ( pScrpInf->scrapState <= 0 ) DisableItem( menu, iPaste );
			if ( (**teHndl).selStart == (**teHndl).selEnd ) {
				i = -1;
				while ( (item=editMenuSelected[++i]) != 0 )
					DisableItem( menu, item ); }	
			break;
		default:
			break;
	}
}

/***** setup cursor *****/
void SetupCursor( WindowPtr window )
{
	CursPtr		iBeamPtr;
	RgnHandle	iBeamRgn, tempRgn;
	short		iType;
	Handle		iHndl;
	Rect		iRect;
	short		i;
	short		items[] = {iTBCreator,iTBBigRF,iTBExclude,0};
	GrafPtr		oldPort;

	if ( WindowType(window) != kMyRefCon ) return;

	GetPort( &oldPort );
	SetPort( (GrafPtr) window );

	iBeamPtr = (CursPtr) NewPtr( sizeof( Cursor ) );

	*iBeamPtr = **GetCursor( iBeamCursor );
	my(window,iBeam) = iBeamPtr;

	iBeamRgn = NewRgn();
	tempRgn  = NewRgn();

	i = -1; while( items[++i] > 0 ) {
		GetDItem( (DialogPtr) window, items[i], &iType, &iHndl, &iRect);
		if ( iRect.left > kLimitDItem ) OffsetRect( &iRect, -kShiftDItem, 0 );
		RectRgn( tempRgn, &iRect );
		UnionRgn( iBeamRgn, tempRgn, iBeamRgn );
	}

	my(window,iBeamRgn) = iBeamRgn;

	DisposeRgn( tempRgn );

//	if ( PtInRgn( mousePos, iBeamRgn ) ) SetCursor( my(window,iBeam) );
//	else SetCursor( &arrow );

	SetPort( oldPort );
}

void AdjustCursor( WindowPtr window, Point mousePos )
{
	GrafPtr		oldPort;

	if ( WindowType(window) != kMyRefCon ) return;

	if ( my(window,mode) != kPrefMode ) return;

	GetPort( &oldPort );
	SetPort( (GrafPtr) window );

//	GetMouse( &mousePos );
	GlobalToLocal( &mousePos );

	if ( PtInRgn(mousePos,my(window,iBeamRgn)) ) SetCursor( my(window,iBeam) );
	else SetCursor( &arrow );

	SetPort( oldPort );
}


/***** setup main window *****/
void DoCloseWindow( WindowPtr window )
{
	if ( WindowType( window ) != kMyRefCon ) return;

	TEDispose( my(window,userTE) );
	DisposeControl( my(window,userCntl) );
	DisposeHandle( (Handle) my(window,posHndl) );

	CloseDialog( (DialogPtr) window );

	DisposPtr( (Ptr) window );
}

void SetupWindow( WindowPtr *theWindow )
{	
	Ptr				dStorage;
	WindowPtr		window;
	PrefDataRecord	dataBlock;
	Rect			wRect;
	Point			thePoint;
	Str255			text;

	SetDAFont( GetDAFont() );

	dStorage = NewPtr( sizeof( myWindowRecord ) );
	window = (WindowPtr) GetNewDialog(kDialogID,dStorage,kMoveToFront);
	if ( window == nil ) {
		ExitToShell(); }

	SetDAFont( systemFont );

	SetWRefCon( window, kMyRefCon );

	GetIndText( kLabelFont, text );
	GetFNum( text, &gTextFont );
	GetIndText( kLabelCheck, text );
	gCheckMark = (unsigned short) text[1];

	if ( LoadRsrcPREF( &dataBlock ) ) {
		thePoint = topLeft( dataBlock.rect );
		MoveWindow( window, thePoint.h, thePoint.v, true );
	} else {
		SetDefaults( (WindowPtr) window, &dataBlock );
		GetWindowRect( (WindowPtr) window, &wRect );
		dataBlock.rect = wRect;
	}

	my(window,pref) = dataBlock;
	SetupUserItem( window );

	SaveDataBlock( (DialogPtr) window, &dataBlock );

	SetupCursor( window );

	my(window,mode) = kPrefMode;
	DoPreference( window );

	SetPort( window );

	ShowWindow( window );

	gWindow = window;
	*theWindow = window;
}


void SetupUserItem( WindowPtr window )
{
	ControlHandle	scrollBar;
	Rect			scrollRect;
	TEHandle		teHndl;
	short			**posHndl;
	short			iType;
	Handle			iHndl;
	Rect			iRect;
	Rect			viewRect;
	short			maxValue;
	GrafPtr			oldPort;

	GetPort( &oldPort );
	SetPort( window );

// setup for 'iUserItem' item
	GetDItem( (DialogPtr) window, iUserItem, &iType, &iHndl, &iRect );

// setup (styled) TextEdit
	viewRect = iRect;
	viewRect.right -= kScrollBarWidth;
	InsetRect( &viewRect, 2, 2 );
	SetupText( window, kTextID, &viewRect, &teHndl );	

//	SetClikLoop( myClickLoopProc, teHndl );
//	TEAutoView( true, teHndl );
//	TESetSelect( 0, 0, teHndl );
//	InvalRect( &viewRect );
	TEDeactivate( teHndl );
	TEUpdate( &viewRect, teHndl );

// setup line position
	maxValue = SetupLinePos( window, teHndl, (Handle *)&posHndl ) + kMinValue;
	my(window,posHndl) = posHndl;

// setup scrollBar
	scrollRect = iRect;
	scrollRect.left = scrollRect.right - kScrollBarWidth;
	scrollBar = NewControl( window, &scrollRect, kEmptyTitle, kVisible,
					kStartValue, kMinValue, maxValue, scrollBarProc, kNilRefCon );
	if ( maxValue < kMinValue ) maxValue = kMinValue;
	SetCtlMax( scrollBar, maxValue );

// save the information about UserItems
	my(window,userItem) = iUserItem;
	my(window,userCntl) = scrollBar;
	my(window,userTE)   = teHndl;

// setup 'iDummy' item
	GetDItem( (DialogPtr) window, iDummy, &iType, &iHndl, &iRect );
	SetDItem( (DialogPtr) window, iDummy,  iType, (Handle)myDrawUserItem, &iRect );

//	SetDialogDefaultItem( (DialogPtr) window, ok );
//	SetDialogCancelItem( (DialogPtr) window, cancel );
//	SetDialogTracksCursor( (DialogPtr) window, true );

	SetPort( oldPort );
}

pascal void myDrawUserItem( DialogPtr dialog, short item )
{
	short			iType;
	Handle			iHndl;
	Rect			iRect;
	GrafPtr			oldPort;

	if ( WindowType(dialog) != kMyRefCon ) return;

	GetPort( &oldPort );
	SetPort( dialog );

	if ( ((WindowPeek)dialog)->hilited )
			HiliteButtons( dialog, kEnableButton );
	else	HiliteButtons( dialog, kDisableButton );

// for 'iUserItem'
	GetDItem( (DialogPtr) dialog, iUserItem, &iType, &iHndl, &iRect );
	iRect.right -= kScrollBarWidth - 1;
	FrameRect( &iRect );

	TEUpdate( &iRect, my(dialog,userTE) );

	SetPort( oldPort );
}

/***** Get information *****/
short GetDAFont( void )
{
	short			fontNumb;
	Handle			rHandle;
	short			rID;
	ResType			rType;
	Str255			rName;
	StringHandle	sHandle;

	fontNumb = systemFont;

	rHandle = Get1IndResource( 'FOND', 1 );
	GetResInfo( rHandle, &rID, &rType, rName );
	GetFNum( (StringPtr) rName, &fontNumb );
	ReleaseResource( (Handle) rHandle );

//	SetDAFont( fontNumb );
//	NoteAlert( kAlertID, nil );
//	SetDAFont( systemFont );

	return( fontNumb );
}

short WindowType( WindowPtr window )
{
	short wType;

	if ( window == nil ) return( kNilRefCon );

	wType = GetWRefCon( window );

	switch ( wType ) {
		case kMyRefCon:
			break;
		default:
			wType = kNilRefCon;
			break;
	}

	return( wType );
}

short	CBitems[] = {iCBCreator,iCBModDate,iCBBigRF,iCBExclude,0};

short CBIndex( short item )
{
	register short	i;

	for ( i=0; ; ++i ) {
		if ( item == CBitems[i] ) break;
		if ( CBitems[i] == 0 ) { i = 0; break; }
	}

	return( i );
}

/***** EventLoop *****/
void EventLoop( void )
{
	Boolean			gotEvent;
	WindowPtr		window;
	DialogPtr		whichDialog;
	EventRecord		event;
	short			itemHit;
	RgnHandle		mouseRgn;

	gOpenAppl = false;
	gOpenDocs = false;

	gDone = false;
	mouseRgn = nil;

//	while ( gDone == false ) {
	while ( !( ( gOpenAppl && gDone ) || ( !gOpenAppl && gOpenDocs ) ) ) {
		gotEvent = WaitNextEvent(everyEvent,&event,kSleep,mouseRgn);
		window = FrontWindow();
		switch ( WindowType( window ) ) {
		case kMyRefCon:
			if ( gotEvent ) {
				AdjustMenuCreator( window );
				AdjustMenuExclude( window );
				if ( ModelessDialog( (DialogPtr)window, &event, &itemHit ) ) {
					if ( HandleHitItem( (DialogPtr)window, itemHit ) ) break; }
				DoEvent( &event );
			} else {
				DialogSelect( &event, &whichDialog, &itemHit );
			}
			break;
		default:
			if ( gotEvent ) DoEvent( &event );
			break;
		}

		LoadDataBlock( (DialogPtr) window, &my(window,pref) );
		SetGlobals( (WindowPtr) window, &my(window,pref) );
		AdjustCursor( window, event.where );
		SystemTask();
	}
}

/***** Do Dialog Event *****/
Boolean HandleHitItem( DialogPtr dialog, short item )
{	
	Rect			wRect;
	PrefDataRecord	dataBlock;
	ControlHandle	theCntl;
	short			curValue;
	Boolean			result;

	result = true;
	switch ( item ) {
		case ok:
			dataBlock = my(dialog,pref);
			GetWindowRect( (WindowPtr) dialog, &wRect );
			dataBlock.rect = wRect;
			SaveRsrcPREF( &dataBlock );
			gDone = true;
			break;
		case cancel:
			gDone = true;
			break;
		case iTitle:
		case iIcon:
			DoAbout();
			break;
		case iUserItem:
//			TEScrollProc( (WindowPtr) dialog, thePoint );
			result = false;
			break;
		case iPref:
			DoPreference( (WindowPtr) dialog );
			break;
		case iCBCreator:
		case iCBModDate:
		case iCBBigRF:
		case iCBExclude:
			theCntl = IGetCtlHand( dialog, item );
			SetCtlValue( theCntl, !GetCtlValue(theCntl) );
			break;
		case iSWCreator:
		case iSWExclude:
			result = false;
			break;
		case iPopupCreator:
			theCntl = IGetCtlHand( dialog, item );
			curValue = TrackPopupMenu( theCntl );
			if ( curValue > 0 )
		 		HandlePopupChoiceCreator( dialog, curValue );
		 	else result = false;
			break;
		case iPopupExclude:
			theCntl = IGetCtlHand( dialog, item );
			curValue = TrackPopupMenu( theCntl );
			if ( curValue > 0 )
		 		HandlePopupChoiceExclude( dialog, curValue );
		 	else result = false;
			break;
		default:
			result = false;
			break;
	}

	return( result );
}

/***** DoEvent *****/
void DoEvent( EventRecord *event )
{
	char	theChar;
	Boolean	toActive;

	switch( event->what ) {
	case kHighLevelEvent:
		AEProcessAppleEvent( event );
		break;
	case mouseDown:
		HandleMouseDown( event );
		break;
	case mouseUp:
	case keyUp:
		break;
	case keyDown:
	case autoKey:
			theChar = event->message & charCodeMask;
			if ( (event->modifiers & cmdKey) != 0 ) {
				AdjustMenu( (WindowPtr) nil );
				HandleMenuChoice( MenuKey( theChar ) ); }
			else
				DoKeyDown( theChar );
			break;
	case updateEvt:
		DoUpdate( (WindowPtr) (event->message), event );
		break;
	case activateEvt:
		toActive = ( (event->modifiers & activeFlag) == activeFlag );
		DoActivate( (WindowPtr) (event->message), toActive );
		break;
	case diskEvt:
	case networkEvt:
	case driverEvt:
	case app1Evt:
	case app2Evt:
	case app3Evt:
	case osEvt:
		DoSuspentResume( event );
		break;
	}
}

/***** Do suspent & resume *****/
void DoSuspentResume( EventRecord *event )
{
	WindowPtr	window;
	long		message;

	window = FrontWindow();

	message = event->message;

 	switch ( ( message >> 24 ) & 0xFF ) {
		case mouseMovedMessage:
			break;
		case suspendResumeMessage:	
			switch ( ( message & 0x03 ) ) {
				case 1:		/* Resume */
					DoActivate( window, true );
					break;
				case 2:		/* Suspend */
					DoActivate( window, false );
					break;
				case 3:		/* Clipboard changed */
					break; }
			break; }
}

/***** Do Activate *****/
void DoActivate( WindowPtr window, Boolean becomingActive )
{	
	short		item;
	GrafPtr		oldPort;

	switch ( WindowType(window) ) {
		case kMyRefCon:
			GetPort( &oldPort );
			SetPort( window );
			if ( becomingActive ) {
				HiliteControl( my(window,userCntl), kEnableButton );
				HiliteButtons( (DialogPtr) window, kEnableButton );
				TEActivate( ((DialogPeek)window)->textH );
//				DrawGrowIcon( window );	
				DrawControls( window );
			} else {
				HiliteControl( my(window,userCntl), kDisableButton );
				HiliteButtons( (DialogPtr) window, kDisableButton );
				TEDeactivate( ((DialogPeek)window)->textH );
				DrawControls( window );
			}
			SetPort( oldPort );
			break;
		default:
			break;
	}
}

/***** Do Update *****/
void DoUpdate( WindowPtr window, EventRecord *event )
{
	GrafPtr		oldPort;

	switch ( WindowType(window) ) {
		case kMyRefCon:
			GetPort( &oldPort );
			SetPort( window );
			BeginUpdate( window );
//				myDrawUserItem( (DialogPtr) window, iUserItem );
				DrawDialog( (DialogPtr) window );
//				DrawGrowIcon( window );	
//				DrawControls( window );
//				UpdateTE( window );
			EndUpdate( window );
			SetPort( oldPort );
			break;
		default:
			break;
	}
}

/***** AEProces event *****/
void SetupAppleEvent( void )
{
	OSErr	err;
	long	feature;

	GestaltCheck( gestaltAppleEventsAttr );

	err = AEInstallEventHandler(kCoreEventClass,kAEOpenApplication,DoOpenApp,0L,false);
	if ( err != noErr )
		DoAEError( kNilAppleEvent, kNilAppleEvent, err, kAEOpenApplication );

	err = AEInstallEventHandler(kCoreEventClass,kAEOpenDocuments,DoOpenDoc,0L,false);
	if ( err != noErr )
		DoAEError( kNilAppleEvent, kNilAppleEvent, err, kAEOpenDocuments );

	err = AEInstallEventHandler(kCoreEventClass,kAEPrintDocuments,DoPrintDoc,0L,false);
	if ( err != noErr )
		DoAEError( kNilAppleEvent, kNilAppleEvent, err, kAEPrintDocuments );

	err = AEInstallEventHandler(kCoreEventClass,kAEQuitApplication,DoQuitApp,0L,false);
	if ( err != noErr )
		DoAEError( kNilAppleEvent, kNilAppleEvent, err, kAEQuitApplication );
}

pascal OSErr DoOpenApp( AppleEvent theAppleEvent, AppleEvent reply, long refCon )
{
	WindowPtr	window;

	SetupWindow( &window );

	gOpenAppl = true;

	return( noErr );
}

pascal OSErr DoOpenDoc( AppleEvent theAppleEvent, AppleEvent reply, long refCon )
{
	PrefDataRecord	dataBlock;
	WindowPtr	window;
	AEDescList	fileSpecList;
	FSSpec		file;
	DescType	type;
	Size		actual;
	long		count;
	AEKeyword	keyword;
	long		index;
	OSErr		err;

	if ( ! gOpenAppl ) {
		window = (WindowPtr) nil;
		if ( ! LoadRsrcPREF( &dataBlock ) )
			SetDefaults( (WindowPtr) window, &dataBlock );
		SetGlobals( (WindowPtr) window, &dataBlock );
	}

	err = AEGetParamDesc( &theAppleEvent, keyDirectObject, typeAEList, &fileSpecList);
	if ( err != noErr ) {
		DoAEError( &theAppleEvent, &reply, err, kNilAppleEventID );
		return( err ); }

	err = GotRequiredParams( &theAppleEvent );
	if ( err != noErr ) {
		DoAEError( &theAppleEvent, &reply, err, kNilAppleEventID );
		return( err ); }

	err = AECountItems( &fileSpecList, &count );
	if ( err != noErr ) {
		DoAEError( &theAppleEvent, &reply, err, kNilAppleEventID );
		return( err ); }

	for (index=1; index<=count; index++) {
		err = AEGetNthPtr( &fileSpecList, index, typeFSS, &keyword, &type,
						   (Ptr) &file, sizeof( FSSpec ), &actual );
		if ( err != noErr ) {
			DoAEError( &theAppleEvent, &reply, err, kNilAppleEventID );
			return( err ); }
		DoPurify( &file );
	}

	AEDisposeDesc( &fileSpecList );

	gOpenDocs = true;

	return( noErr );
}

pascal OSErr DoPrintDoc( AppleEvent theAppleEvent, AppleEvent reply, long refCon )
{
	return( noErr );
}

pascal OSErr DoQuitApp( AppleEvent theAppleEvent, AppleEvent reply, long refCon )
{
	gDone = true;

	return( noErr );
}

OSErr GotRequiredParams( AppleEvent *appleEventPtr )
{
	DescType	returnedType;
	Size		actualSize;
	OSErr		err;

	err = AEGetAttributePtr( appleEventPtr, keyMissedKeywordAttr, typeWildCard,
							 &returnedType, nil, 0, &actualSize );

	if ( err == errAEDescNotFound ) return( noErr );
	else if ( err = noErr ) return( errAEEventNotHandled );
	else return( err );
}

void DoAEError( AppleEvent *theAppleEvent, AppleEvent *reply, OSErr err, long eventID )
{
	StringPtr	s;

	switch ( eventID ) {
		case kAEOpenApplication:	s = "\pOpen Application"; break;
		case kAEOpenDocuments:		s = "\pOpen Documents"; break;
		case kAEPrintDocuments:		s = "\pPrint Documents"; break;
		case kAEQuitApplication:	s = "\pQuit Application"; break;
		default:					s = "\pUnknown Apple Event"; break; }

	if ( theAppleEvent == nil ) {
		StopMessage( kErrAppleEvent, kEmptyString, s, 0 );
		ExitToShell();
	} else {
		NoteMessage( kErrAppleEvent, kEmptyString, ErrAE(err), 0 );
	}
}

/***** Do Purity *****/
void DoPurify( FSSpec *theFSSpec )
{
	Boolean		tryToDo;
	short		dstFile;
	HFileParam	orgFInfo;
	Size		theSize;
	long		feature;
	OSErr		err;

// Gestalt check
	GestaltCheck( gestaltFSAttr );

// Get FileInfo
	if ( gCBCreator || gCBModDate ) DoGetFInfo( theFSSpec, &orgFInfo );

// File open
	err = FSpOpenRF( theFSSpec, fsRdWrPerm, &dstFile );
	if ( err != noErr ) {
		NoteMessage( kErrFileSystem, theFSSpec->name, ErrFS(err), err );
		return; }

	err = GetEOF( dstFile, &theSize );
	if ( err != noErr ) {
		NoteMessage( kErrFileSystem, theFSSpec->name, ErrFS(err), err );
		return; }

	tryToDo = true;

	if ( gCBExclude && IsExclude( theFSSpec ) ) 
		tryToDo = false;
	else if ( gCBBigRF && ( (signed) theSize > gBigRF ) )
		tryToDo = CautionMessage(	kMsgSurePurify, theFSSpec->name,
									kEmptyString, theSize );

	if ( tryToDo ) {
	err = SetEOF( dstFile, 0L );

	if ( err != noErr ) {
		NoteMessage( kErrFileSystem, theFSSpec->name, ErrFS(err), err );
		return; }
	}

	FSClose( dstFile );

	if ( tryToDo && ( gCBCreator || gCBModDate ) )
		DoSetFInfo( theFSSpec, &orgFInfo );

	FlushVol( nil, theFSSpec->vRefNum );
}

void DoGetFInfo( FSSpec *theFSSpec, HFileParam *fInfo )
{
	OSErr		err;

	fInfo->ioNamePtr	= theFSSpec->name;
	fInfo->ioVRefNum	= theFSSpec->vRefNum;
	fInfo->ioDirID		= theFSSpec->parID;
	fInfo->ioFDirIndex	= 0;

	err = PBHGetFInfo( (HParmBlkPtr) fInfo, false );

	if ( err != noErr ) {
		NoteMessage( kErrFileSystem, theFSSpec->name, ErrFS(err), err );
		return; }
}

void DoSetFInfo( FSSpec *theFSSpec, HFileParam *oldFInfo )
{
	HFileParam	newFInfo;
	OSErr		err;

	DoGetFInfo( theFSSpec, &newFInfo );

	newFInfo.ioNamePtr		= theFSSpec->name;
	newFInfo.ioVRefNum		= theFSSpec->vRefNum;
	newFInfo.ioDirID		= theFSSpec->parID;
	if ( gCBCreator ) newFInfo.ioFlFndrInfo.fdCreator = gCreator;
	if ( gCBModDate ) newFInfo.ioFlMdDat = oldFInfo->ioFlMdDat;

	err = PBHSetFInfo( (HParmBlkPtr) &newFInfo, false );

	if ( err != noErr ) {
		NoteMessage( kErrFileSystem, theFSSpec->name, ErrFS(err), err );
		return; }

//	PBFlushVol( (ParmBlkPtr) &newFInfo, false );
	PBFlushFile( (ParmBlkPtr) &newFInfo, false );
}

Boolean IsExclude( FSSpec *theFSSpec )
{
	register short	i;
	FInfo	theFInfo;
	OSType	type;

	if ( FSpGetFInfo( theFSSpec, &theFInfo ) != noErr ) return( false );

	type = theFInfo.fdCreator;

	for (i=0;i<gNumExcludes;++i)
		if ( type == gExcludes[i] ) return( true );

	return( false );
}

Boolean GetFileCreator( OSType *type )
{
	short		numTypes = 4;
	SFTypeList	typeList = {'TEXT','PICT','SITD','APPL'};
	FSSpec		theFSSpec;
	FInfo		theFInfo;

	if ( ! GetFileDialog( numTypes, typeList, &theFSSpec ) ) return( false );

	if ( FSpGetFInfo( &theFSSpec, &theFInfo ) != noErr ) return( false );

	*type = theFInfo.fdCreator;

	return( true );
}

/***** Handle MouseDown *****/
void HandleMouseDown( EventRecord *event )
{
	WindowPtr		window;
	long			menuChoice;
	short			thePart;

	thePart = FindWindow( event->where, &window );

	switch( thePart ) {
		case inMenuBar:
			AdjustMenu( (WindowPtr) nil );
			menuChoice = MenuSelect( event->where );
			HandleMenuChoice( menuChoice );
			break;
		case inSysWindow:
			SystemClick( event, window );
			break;
		case inDrag:
			DragWindow( window, event->where, &screenBits.bounds );
			break;
		case inContent:
			if ( window != FrontWindow() ) {
				SelectWindow( window ); }
			else {
				DoContent( window, event ); }
			break;
		case inGoAway:
			if ( TrackGoAway( window, event->where ) ) gDone = true;
			break;
	}
}

/***** Do content *****/
void DoContent( WindowPtr window, EventRecord *event  )
{
	short			curValue;
	Point			thePoint;
	short			thePart;
	short			item;
	short			iType;
	Handle			iHndl;
	Rect			iRect;
	GrafPtr			oldPort;

	if ( WindowType(window) != kMyRefCon ) return;

	GetPort( &oldPort );
	SetPort( window );

	thePoint = event->where;
	GlobalToLocal( &thePoint );

// test for 'iUserItem' area
	item = iUserItem;
	GetDItem( (DialogPtr) window, item, &iType, &iHndl, &iRect );
	if ( PtInRect( thePoint, &iRect ) ) {
		TEScrollProc( (WindowPtr) window, thePoint );
		goto quit;
	}

// test for 'SWCreator' area
	item = iSWCreator;
	GetDItem( (DialogPtr) window, item, &iType, &iHndl, &iRect );
	if ( PtInRect( thePoint, &iRect ) ) {
		if ( SelectPopupMenu( window, item, &curValue ) ) {
		 	HandlePopupChoiceCreator( window, curValue ); }
		goto quit;
	}

// test for 'SWExclude' area
	item = iSWExclude;
	GetDItem( (DialogPtr) window, item, &iType, &iHndl, &iRect );
	if ( PtInRect( thePoint, &iRect ) ) {
		if ( SelectPopupMenu( window, item, &curValue ) ) {
		 	HandlePopupChoiceExclude( window, curValue ); }
		goto quit;
	}

quit:
	SetPort( oldPort );
}

/***** Handle PopupMenu *****/
Boolean SelectPopupMenu( WindowPtr window, short item, short *curValue )
{
	Point			thePoint;
	short			thePart;
	ControlHandle	theCntl;
	MenuHandle		theMenu;
	short			iType;
	Handle			iHndl;
	Rect			iRect;
	short			popupItem;
	Str255			text;
	GrafPtr			oldPort;

	if ( WindowType(window) != kMyRefCon ) return( false );

	switch ( item ) {
		case iSWCreator:
			theMenu = GetMenu( mCreator );
//			AdjustMenuCreator( window );
			GetIText( IGetTxtHand((DialogPtr)window,iTBCreator), text );
			popupItem = GetMenuInd( theMenu, text );
			thePart = ( ( popupItem >= ipcFirst ) ? popupItem : ipcFirst );
			break;
		case iSWExclude:
			theMenu = GetMenu( mExclude );
//			AdjustMenuExclude( window );
			GetIText( IGetTxtHand((DialogPtr)window,iTBExclude), text );
			popupItem = GetMenuInd( theMenu, text );
			thePart = ( ( popupItem >= ipeFirst ) ? popupItem : ipeFirst );
			break;
		default:
			return( false ); }

	GetPort( &oldPort );
	SetPort( window );

//	GetMouse( &thePoint );
	GetDItem( (DialogPtr) window, item, &iType, &iHndl, &iRect );
	thePoint = topLeft( iRect );
	LocalToGlobal( &thePoint );

	InsertMenu( theMenu, hierMenu );
	thePart = PopUpMenuSelect( theMenu, thePoint.v, thePoint.h, thePart );
	DeleteMenu( (**theMenu).menuID );

	SetPort( oldPort );

	if ( thePart <= 0 ) return( false );

	*curValue = thePart;

	return( true );
}

void AdjustMenuCreator( WindowPtr window )
{
	short			i,item,itemTB;
	short			items[] = {ipcAdd,ipcAppend,ipcRemove,0};
	MenuHandle		menu;

	itemTB = iTBCreator;
	menu = GetMenu( mCreator );

	i = -1;
	while ( (item=items[++i]) != 0 ) EnableItem( menu, item );

	if ( ! TestPopupAdd(window,menu,itemTB) ) DisableItem( menu, ipcAdd );
	if ( ! TestPopupAppend(window,menu,itemTB) ) DisableItem( menu, ipcAppend );
	if ( ! TestPopupRemove(window,menu,itemTB) ) DisableItem( menu, ipcRemove );

	DoPopupReset( window, menu, itemTB );
}

void AdjustMenuExclude( WindowPtr window )
{
	short			i,item,itemTB;
	short			items[] = {ipeAdd,ipeAppend,ipeRemove,ipeEnable,ipeDisable,0};
	short			markChar;
	MenuHandle		menu;
	Str255			text;

	itemTB = iTBExclude;
	menu = GetMenu( mExclude );

	i = -1;
	while ( (item=items[++i]) != 0 ) EnableItem( menu, item );

	if ( ! TestPopupAdd(window,menu,itemTB) ) DisableItem( menu, ipeAdd );
	if ( ! TestPopupAppend(window,menu,itemTB) ) DisableItem( menu, ipeAppend );
	if ( ! TestPopupRemove(window,menu,itemTB) ) DisableItem( menu, ipeRemove );

	GetIText( IGetTxtHand((DialogPtr)window,itemTB), text );
	item = GetMenuInd( menu, text );
	if ( item > 0 ) GetItemCheck( menu, item, &markChar );

	if ( item == 0 ) {
		DisableItem( menu, ipeEnable );
		DisableItem( menu, ipeDisable ); }
	else if ( item == ipeFirst ) {
		DisableItem( menu, ipeEnable );
		DisableItem( menu, ipeDisable ); }
	else if ( markChar == noMark ) {
		EnableItem(  menu, ipeEnable );
		DisableItem( menu, ipeDisable ); }		
	else {
		DisableItem( menu, ipeEnable );
		EnableItem(  menu, ipeDisable ); }

	DoPopupReset( window, menu, itemTB );
}

void HandlePopupChoiceCreator( WindowPtr window, short itemHit )
{
	MenuHandle	menu;
	short		item;

	item = iTBCreator;
	menu = GetMenu( mCreator );

	switch ( itemHit ) {
		case ipcAdd:
			DoPopupAdd( window, menu, item );
			break;
		case ipcAppend:
			DoPopupAppend( window, menu, item );
			break;
		case ipcRemove:
			DoPopupRemove( window, menu, item );
			break;
		default:
			DoPopupSetText( window, menu, item, itemHit );
		 	break;
	}
}

void HandlePopupChoiceExclude( WindowPtr window, short itemHit )
{
	MenuHandle		menu;
	short			i,item;
	short			markChar;
	OSType			type,type1,type2;
	Str255			text;

	item = iTBExclude;
	menu = GetMenu( mExclude );

	switch ( itemHit ) {
		case ipeAdd:
			if ( DoPopupAdd( window, menu, item ) )
				SetItemCheck( menu, CountMItems(menu), dCheckMark );
			break;
		case ipeAppend:
			DoPopupAppend( window, menu, item );
			SetItemCheck( menu, CountMItems(menu), dCheckMark );
			break;
		case ipeRemove:
			DoPopupRemove( window, menu, item );
		 	GetIText( IGetTxtHand((DialogPtr)window,item), text );
		 	StringToTyp(text,&type); TypToString(type,text);
		 	SetIText( IGetTxtHand((DialogPtr)window,item), text );
			break;
		case ipeEnable:
		case ipeDisable:
			GetIText( IGetTxtHand((DialogPtr)window,item), text );
			i = GetMenuInd( menu, text );
			if ( i > 0 )
			SetItemCheck( menu, i, ((itemHit==ipeEnable)?dCheckMark:noMark) );
			break;
		default:
		 	GetIText( IGetTxtHand((DialogPtr)window,item), text );
		 	StringToTyp( text, &type2 );
			DoPopupSetText( window, menu, item, itemHit );
		 	GetIText( IGetTxtHand((DialogPtr)window,item), text );
		 	StringToTyp( text, &type1 );
		 	if ( itemHit == ipeFirst ) break;
		 	if ( type1 != type2 ) break;
		 	GetItemCheck( menu, itemHit, &markChar );
		 	SetItemCheck( menu, itemHit, ((markChar==noMark)?dCheckMark:noMark) );
		 	break;
	}

	AppendCheckMark( window, menu, item );
}

/***** Do popup operation *****/
Boolean TestPopupAdd( WindowPtr window, MenuHandle menu, short item )
{
	short		i,iFirst;
	Str255		text;

	switch ( item ) {
		case iTBCreator:	iFirst = ipcFirst; break;
		case iTBExclude:	iFirst = ipeFirst; break;
		default:
			return( false ); }

	GetIText( IGetTxtHand((DialogPtr)window,item), text );

//	NoteMessage( kErrMaxCreators, kEmptyString, kEmptyString, kMaxCreators-1 );

	if ( CountMItems(menu)-iFirst+1 >= kMaxCreators-1 )  return( false );

	return( true );
}

Boolean TestPopupAppend( WindowPtr window, MenuHandle menu, short item )
{
	short		i,iFirst;
	Str255		text;

	switch ( item ) {
		case iTBCreator:	iFirst = ipcFirst; break;
		case iTBExclude:	iFirst = ipeFirst; break;
		default:
			return( false ); }

	GetIText( IGetTxtHand((DialogPtr)window,item), text );

//	NoteMessage( kErrMaxCreators, kEmptyString, kEmptyString, kMaxCreators-1 );

	if ( CountMItems(menu)-iFirst+1 >= kMaxCreators-1 )  return( false );
	if ( text[1] == '-' )  return( false );
	if ( text[0] < 4 )  return( false );
	if ( GetMenuInd(menu,text) > 0 )  return( false );

	return( true );
}

Boolean TestPopupRemove( WindowPtr window, MenuHandle menu, short item )
{
	short		i,iFirst;
	Str255		text;

	switch ( item ) {
		case iTBCreator:	iFirst = ipcFirst; break;
		case iTBExclude:	iFirst = ipeFirst; break;
		default:
			return( false ); }

	GetIText( IGetTxtHand((DialogPtr)window,item), text );

	i = GetMenuInd(menu,text);
	if ( i <= 0 )  return( false );
	if ( i == iFirst )  return( false );

	return( true );
}

Boolean DoPopupReset( WindowPtr window, MenuHandle menu, short item )
{
	short			i,iFirst,iNumb;
	ControlHandle	ppCntl;
	Str255			text;

	switch ( item ) {
		case iTBCreator:
			iFirst = ipcFirst;
			ppCntl = IGetCtlHand( (DialogPtr)window, iPopupCreator );
			break;
		case iTBExclude:
			iFirst = ipeFirst;
			ppCntl = IGetCtlHand( (DialogPtr)window, iPopupExclude );
			break;
		default:
			return( false ); }

	iNumb = CountMItems( menu );

	GetIText( IGetTxtHand((DialogPtr)window,item), text );
	i = GetMenuInd( menu, text );

	i = ( ( i >= iFirst ) ? i : iFirst );
//	if ( i == GetCtlValue( ppCntl ) ) return( false );
//	if ( iNumb == GetCtMax( ppCntl ) ) return( false );

	SetCtlMax( ppCntl, iNumb );
	SetCtlValue( ppCntl, i );

	return( true );
}

Boolean DoPopupSetText( WindowPtr window, MenuHandle menu, short item, short itemHit )
{
	short		i,iFirst;
	OSType		type;
	Str255		text;

	switch ( item ) {
		case iTBCreator:	iFirst = ipcFirst; break;
		case iTBExclude:	iFirst = ipeFirst; break;
		default:
			return( false ); }

	GetItem( menu, itemHit, text );

	StringToTyp( text, &type );
	TypToString( type, text );

 	SetIText( IGetTxtHand((DialogPtr)window,item), text );
 	
 	SelIText( (DialogPtr)window, item, 0, MAXINT );

 	return( true );
}

Boolean DoPopupAdd( WindowPtr window, MenuHandle menu, short item )
{
	short		i,iFirst;
	OSType		type;
	Str255		text;

	switch ( item ) {
		case iTBCreator:	iFirst = ipcFirst; break;
		case iTBExclude:	iFirst = ipeFirst; break;
		default:
			return( false ); }

	if ( ! GetFileCreator( &type ) ) return( false );

	TypToString(type,text);
 	SetIText( IGetTxtHand((DialogPtr)window,item), text );

	if ( GetMenuInd(menu,text) != 0 ) return( false );

	AppendMenuItem( menu, text );

	return( true );
}

Boolean DoPopupAppend( WindowPtr window, MenuHandle menu, short item )
{
	short		i,iFirst;
	OSType		type;
	Str255		text;

	switch ( item ) {
		case iTBCreator:	iFirst = ipcFirst; break;
		case iTBExclude:	iFirst = ipeFirst; break;
		default:
			return( false ); }

	if ( CountMItems(menu)-iFirst+1 >= kMaxCreators-1 ) return( false );

	GetIText( IGetTxtHand((DialogPtr)window,item), text );

	StringToTyp(text,&type);
	TypToString(type,text);

	AppendMenuItem( menu, text );

	return( true );
}

Boolean DoPopupRemove( WindowPtr window, MenuHandle menu, short item )
{
	short		i,iFirst;
	OSType		type;
	Str255		text;

	switch ( item ) {
		case iTBCreator:	iFirst = ipcFirst; break;
		case iTBExclude:	iFirst = ipeFirst; break;
		default:
			return( false ); }

	GetIText( IGetTxtHand((DialogPtr)window,item), text );

	i = GetMenuInd( menu, text );
	if ( i <= iFirst ) return( false );

	DelMenuItem( menu, i );

	return( true );
}

Boolean AppendCheckMark( WindowPtr window, MenuHandle menu, short item )
{
	short			iFirst;
	short			i,k,n;
	short			itemWidth, widthSP, widthMark;
	short			markChar;
	short			iType;
	Handle			iHndl;
	Rect			iRect;
	OSType			type;
	Str255			text;
	GrafPtr			oldPort;

	switch ( item ) {
		case iTBCreator:	iFirst = ipcFirst; break;
		case iTBExclude:	iFirst = ipeFirst; break;
		default:
			return( false ); }

	GetDItem( (DialogPtr) window, item, &iType, &iHndl, &iRect );

	GetIText( (Handle)iHndl, text );

	StringToTyp(text,&type);
	TypToString(type,text);

	i = GetMenuInd( menu, text );
	if ( i < iFirst ) return( false );

	GetItemCheck( menu, i, &markChar );

	if ( markChar != noMark ) {
		GetPort( &oldPort );
		SetPort( window );

//		TextFont( gTextFont );
		TextFont( geneva );
		TextSize( 9 );

		itemWidth = iRect.right - iRect.left;
		widthSP = CharWidth( ' ' );
		widthMark = CharWidth( dCheckMark );
		k = ( itemWidth - StringWidth(text) - widthMark - 1 ) / widthSP;

		n = text[0];
		while ( --k >= 0 ) text[++n] = ' ';
		text[++n] = dCheckMark;
		text[0] = n;

		SetPort( oldPort );
	}

	SetIText( (Handle)iHndl, text );

	return( true );
}

/***** Do key down *****/
void DoKeyDown( char c )
{
	WindowPtr	window;
	short		item;

	window = FrontWindow();

	switch ( WindowType(window) ) {
		case kMyRefCon:
			break;
		default:
			break;
	}
}

/***** Handle MenuChoice *****/
void HandleMenuChoice( long menuChoice )
{
	short	menu;
	short	item;

	if ( menuChoice != 0 ) {
		menu = HiWord( menuChoice );
		item = LoWord( menuChoice );
		switch ( menu ) {
			case mApple:
				HandleAppleChoice( item );
				break;
			case mFile:
				HandleFileChoice( item );
				break;
			case mEdit:
				HandleEditChoice( item );
				break;
			default:
				break; }

		HiliteMenu( 0 );
	}
}

/***** Handle Apple Choice *****/
void HandleAppleChoice( short item )
{
	MenuHandle	appleMenu;
	Str31		accName;
	short		accNumber;

	switch ( item ) {
		case iAbout:
			DoAbout();
			break;
		default:
			appleMenu = GetMHandle( mApple );
			GetItem( appleMenu, item, accName );
			accNumber = OpenDeskAcc( accName );
			break;
	}
}

/***** Handle File Choice *****/
void HandleFileChoice( short item )
{
	switch ( item ) {
		case iQuit:
			gDone = true;
			break;
		case iOpen:
			DoOpen();
			break;
		case iNew:
		case iClose:
		case iSave:
		case iSaveAs:
			DoSaveAs();
			break;
		case iPageSetup:
		case iPrint:
			break;
		case iPreferences:
			DoPreference( (WindowPtr) nil );
			break;
		default:
			break;}
}

/***** Handle Edit Choice *****/
void HandleEditChoice( short theItem )
{
	WindowPtr	window;
	TEHandle	teHndl;
	short		item;

	if ( SystemEdit( theItem - 1 ) ) return;

	window = FrontWindow();
	if ( WindowType(window) != kMyRefCon ) return;

	if ( my(window,mode) != kPrefMode ) return;

	teHndl = ((DialogPeek)window)->textH;

	switch ( theItem ) {
		case iUndo:
			break;
		case iCut:
			if ( ZeroScrap() == noErr ) {
				TECut(teHndl);
				if ( TEToScrap() != noErr ) ZeroScrap(); }
			break;
		case iCopy:
			if ( ZeroScrap() == noErr ) {
				TECopy(teHndl);
				if ( TEToScrap() != noErr ) ZeroScrap(); }
			break;
		case iPaste:
			if ( TEFromScrap() == noErr ) {
//				TEStylPaste(teHndl);
				TEPaste(teHndl); }
			break;
		case iClear:
			TEDelete(teHndl);
			break;
		case iDuplicate:
//			TECopy(teHndl);
//			TEPaste(teHndl);
//			TEStylPaste(teHndl);
			break;
		case iSelectAll:
			TESetSelect( 0, MAXINT, teHndl );
			break;
		default:
			break; }
}

/***** Do something ******/
/***** Do About *****/
void DoAbout( void )
{
	Alert( kAboutID, nil );
//	NoteAlert( kAboutID, nil );
}

/***** Do File Open *****/
void DoOpen( void )
{
	short			numTypes;		// -1 for all, 0 for nothing
	SFTypeList		typeList;		// OSType typeList[4]
	FSSpec			theFSSpec;

	numTypes = 3;
	typeList[0] = 'TEXT';
	typeList[1] = 'PICT';
	typeList[2] = 'SITD';

	if ( GetFileDialog( numTypes, typeList, &theFSSpec ) )
		DoPurify( &theFSSpec );
}

/***** Do Save HELP *****/
void DoSaveAs( void )
{
	FSSpec		theFSSpec;
	Boolean		replacing;
	Str255		text;

	GetIndText( kLabelDoc, text );
	Pstrcpy( theFSSpec.name, text );
//	Pstrcpy( theFSSpec.name, "\ppuriTEXT.doc" );

	GetIndText( kLabelSaveAs, text );
	if ( PutFileDialog( text, &replacing, &theFSSpec ) )
//	if ( PutFileDialog( "\pSave HELP document as ...", &replacing, &theFSSpec ) )
		DoSaveHelp( &theFSSpec, replacing );

}

void DoSaveHelp( FSSpec *theFSSpec, Boolean replacing )
{
	WindowPtr	window;
	CharsHandle	hText;
	short		dstFile;
	Size		theSize;
	OSErr		err;

	window = FrontWindow();
	if ( WindowType(window) != kMyRefCon ) return;

// Gestalt check
	GestaltCheck( gestaltFSAttr );

// File create
	if ( ! replacing ) {
		err = FSpCreate( theFSSpec, 'ttxt', 'TEXT', smSystemScript );
		if ( err != noErr ) {
			NoteMessage( kErrFileSystem, theFSSpec->name, ErrFS(err), err );
			return; }
	}

// File open
	err = FSpOpenDF( theFSSpec, fsWrPerm, &dstFile );
	if (  err != noErr ) {
		NoteMessage( kErrFileSystem, theFSSpec->name, ErrFS(err), err );
		return; }

	hText = TEGetText( my(window,userTE) );
	theSize = GetHandleSize( hText );

	HLock( (Handle) hText );

	err = FSWrite( dstFile, &theSize, *hText );

	HUnlock(  (Handle) hText  );

	FSClose( dstFile );

	if ( err != noErr ) {
		NoteMessage( kErrFileSystem, theFSSpec->name, ErrFS(err), err );
		return;
	}

	FlushVol( nil, theFSSpec->vRefNum );

	return;
}

/***** Do Preference *****/
void SetDefaults( WindowPtr window, PrefDataPtr dataBlock )
{
	short	i;
	long	flag;

	dataBlock->check[ CBIndex(iCBCreator) ]	= false;
	dataBlock->check[ CBIndex(iCBModDate) ]	= true;
	dataBlock->check[ CBIndex(iCBBigRF) ]	= true;
	dataBlock->check[ CBIndex(iCBExclude) ]	= true;

	dataBlock->creator	= 'ttxt';
	dataBlock->exclude	= 'MzpT';
	dataBlock->sizeRF	= 10;

	for (i=0;i<kMaxCreators;++i)
		dataBlock->creators[i] = kNilOSType;
	for (i=0;i<kMaxCreators;++i)
		dataBlock->excludes[i] = kNilOSType;

	dataBlock->creators[0] = 'ttxt';
	dataBlock->creators[1] = 'R*ch';
	dataBlock->creators[2] = 'KAHL';
	dataBlock->creators[3] = 'AEDT';
	dataBlock->excludes[0] = 'MzpT';
	dataBlock->excludes[1] = 'SIT!';
	dataBlock->excludes[2] = 'KAHL';
	dataBlock->excludes[3] = 'ttxt';

	flag = 0;
	BitSet( &flag, 0 );
	BitSet( &flag, 1 );
	BitSet( &flag, 2 );
	dataBlock->flag = flag;
}

void SetGlobals( WindowPtr window, PrefDataPtr dataBlock )
{
	Str255			text;
	OSType			type;
	long			flag;
	MenuHandle		menu;
	short			n,m,i,item;
	short			markChar;

	gCBCreator	= dataBlock->check[ CBIndex(iCBCreator) ];
	gCBModDate	= dataBlock->check[ CBIndex(iCBModDate) ];
	gCBBigRF	= dataBlock->check[ CBIndex(iCBBigRF) ];
	gCBExclude	= dataBlock->check[ CBIndex(iCBExclude) ];

	gCreator	= dataBlock->creator;
	gBigRF		= 1024 * dataBlock->sizeRF;

	m = 0;
	flag = dataBlock->flag;
	for (i=0;i<kMaxCreators;++i) {
		type = dataBlock->excludes[i];
		if ( type == kNilOSType ) break;
		if( BitTst(&flag,i) == 1) gExcludes[m++] = type;
	}
	gNumExcludes = m;
}

void DoPreference( WindowPtr window )
{
//	WindowPtr		window;
	ControlHandle	userCntl,theCntl;
	TEHandle		userTE;
	Str255			text;
	short	i,item;
	short	items[] = { iCBCreator,iCBModDate,iCBBigRF,iCBExclude,iTextKB,
						iTBCreator,iTBBigRF,iTBExclude,iSWCreator,iSWExclude,
						iPopupCreator,iPopupExclude,0};

	if ( window == nil ) window = FrontWindow();

	if ( WindowType(window) != kMyRefCon ) return;

	theCntl  = IGetCtlHand( (DialogPtr) window, iPref);
	userCntl = my(window,userCntl);
	userTE   = my(window,userTE);

	switch ( my(window,mode) ) {
		case kNormalMode:
			GetIndText( kLabelHelp, text );
			SetCTitle( theCntl, text );
//			SetCTitle( theCntl, "\pHelp" );
			HideDItem( (DialogPtr) window, iUserItem );
			HideControl( userCntl );
			if ( ((**userTE).destRect).left < kLimitDItem ) {
				OffsetRect( &((**userTE).destRect),  kShiftDItem, 0 );
				OffsetRect( &((**userTE).viewRect),  kShiftDItem, 0 ); }
			i = -1; while ( (item=items[++i]) > 0 )
				ShowDItem( (DialogPtr) window, item ); 
			my(window,mode) = kPrefMode;
			break;
		case kPrefMode:
			GetIndText( kLabelPref, text );
			SetCTitle( theCntl, text );
//			SetCTitle( theCntl, "\pPref" );
			i = -1; while ( (item=items[++i]) > 0 )
				HideDItem( (DialogPtr) window, item ); 
			if ( ((**userTE).destRect).left > kLimitDItem ) {
				OffsetRect( &((**userTE).destRect), -kShiftDItem, 0 );
				OffsetRect( &((**userTE).viewRect), -kShiftDItem, 0 ); }
			ShowControl( userCntl );
			ShowDItem( (DialogPtr) window, iUserItem );
			my(window,mode) = kNormalMode;
			break;
		default:
			break;
	}
}

/***** Dialog operation *****/
void LoadDataBlock( DialogPtr dialog, PrefDataPtr dataBlock )
{
	Str255			text;
	OSType			type;
	long			size, flag;
	MenuHandle		menu;
	short			n,i, item;
	short			markChar;

	if ( WindowType((WindowPtr)dialog) != kMyRefCon ) return;

	i = -1;
	while ( (item=CBitems[++i]) != 0 ) {
		dataBlock->check[CBIndex(item)] = GetCtlValue( IGetCtlHand(dialog,item) );
	}

	GetIText( IGetTxtHand(dialog,iTBCreator), text );
	StringToTyp(text,&type);
	dataBlock->creator = type;

	GetIText( IGetTxtHand(dialog,iTBExclude), text );
	StringToTyp(text,&type);
	dataBlock->exclude = type;

	GetIText( IGetTxtHand(dialog,iTBBigRF), text );
	StringToNum( text, &size );
	dataBlock->sizeRF = size;

	menu = GetMenu( mCreator );
	n = CountMItems( menu ) - ipcFirst + 1;
	for (i=0;( i < n  &&  i < (kMaxCreators-1));++i) {
		GetItem( menu, i+ipcFirst, text );
		StringToTyp(text,&type);
		dataBlock->creators[i] = type; }
	dataBlock->creators[i] = kNilOSType;

	menu = GetMenu( mExclude );
	n = CountMItems( menu ) - ipeFirst + 1;
	for (i=0;( i < n  &&  i < (kMaxCreators-1));++i) {
		GetItem( menu, i+ipeFirst, text );
		StringToTyp(text,&type);
		dataBlock->excludes[i] = type; }
	dataBlock->excludes[i] = kNilOSType;

	flag = 0;
	for (i=0;(i<n && i<kMaxCreators);++i) {
		GetItemCheck( menu, i+ipeFirst, &markChar );
		if ( markChar != noMark ) BitSet( &flag, i );
	}
	dataBlock->flag = flag;
}

void SaveDataBlock( DialogPtr dialog, PrefDataPtr dataBlock )
{
	Str255			text;
	OSType			type;
	long			size, flag;
	MenuHandle		menu;
	short			n,i, item;
	short			markChar;

	if ( WindowType((WindowPtr)dialog) != kMyRefCon ) return;

	i = -1;
	while ( (item=CBitems[++i]) != 0 ) {
		SetCtlValue( IGetCtlHand(dialog,item), dataBlock->check[CBIndex(item)] );
	}

	type = dataBlock->creator;
	TypToString(type,text);
	SetIText( IGetTxtHand(dialog,iTBCreator), text );

	type = dataBlock->exclude;
	TypToString(type,text);
	SetIText( IGetTxtHand(dialog,iTBExclude), text );

	size = dataBlock->sizeRF;
	NumToString( size, text );
	SetIText( IGetTxtHand(dialog,iTBBigRF), text );

	SetCtlValue( IGetCtlHand(dialog,iPopupCreator), ipcFirst );
	SetCtlValue( IGetCtlHand(dialog,iPopupExclude), ipeFirst );

	menu = GetMenu( mCreator );
	n = CountMItems( menu ) - ipcFirst + 1;
	for (i=0;i<n;++i) DelMenuItem( menu, ipcFirst );
	for (i=0;i<kMaxCreators;++i) {
		type = dataBlock->creators[i];
		if ( type == kNilOSType ) break;
		TypToString(type,text);
		AppendMenuItem( menu, text ); }

	menu = GetMenu( mExclude );
	n = CountMItems( menu ) - ipeFirst + 1;
	for (i=0;i<n;++i) DelMenuItem( menu, ipeFirst );
	for (i=0;i<kMaxCreators;++i) {
		type = dataBlock->excludes[i];
		if ( type == kNilOSType ) break;
		TypToString(type,text);
		AppendMenuItem( menu, text ); }

	flag = dataBlock->flag;
	n = CountMItems( menu ) - ipeFirst + 1;
	for (i=0;(i<n && i<kMaxCreators);++i) {
		SetItemCheck( menu, i+ipeFirst, ((BitTst(&flag,i)==1)?dCheckMark:noMark) ); }

	AppendCheckMark( (WindowPtr) dialog, menu, iTBExclude );
}

void HiliteButtons( DialogPtr dialog, short hiliteCode )
{
	short			iType;
	Handle			iHndl;
	Rect			iRect;
	PenState		savePenState;
	ControlHandle	theCntl;
	short	i, item;
	short	items[] = { ok,cancel,iPref,
						iCBCreator,iCBModDate,iCBBigRF,iCBExclude,
						iPopupCreator, iPopupExclude,0};
	GrafPtr	oldPort;

//	hiliteCode = { kEnableButton(0), kDisableButton(255) }

	if ( WindowType((WindowPtr) dialog ) != kMyRefCon ) return;

	GetPort( &oldPort );
	SetPort( dialog );

	i = -1;
	while ( (item=items[++i]) != 0 ) {
		theCntl = IGetCtlHand( (DialogPtr) dialog, item );
		HiliteControl( theCntl, hiliteCode );
	}

// for 'ok' item
	GetDItem( (DialogPtr) dialog, ok, &iType, &iHndl, &iRect);
	HiliteControl( (ControlHandle)iHndl, hiliteCode );
	GetPenState( &savePenState );
	PenNormal();
	if ( hiliteCode == kEnableButton ) PenPat( black ); else PenPat( gray );
	PenSize( 3,3 );
	InsetRect( &iRect, -4,-4);
	FrameRoundRect( &iRect, 16,16 );
	SetPenState( &savePenState );

	SetPort( oldPort );
}

/***** End of Program *****/
